//<c>   Copyright 1997-1998 by Gerry J. Danen; all rights reserved.

//<t>   Get CallerID info from McMail (or other mailer's) log file

//~ 31 Mar 12:43:03 McM  Serial: [cidinfo] DATE = 0331
//~ 31 Mar 12:43:03 McM  Serial: [cidinfo] TIME = 1240
//~ 31 Mar 12:43:03 McM  Serial: [cidinfo] NAME = DAVIES R D
//~ 31 Mar 12:43:03 McM  Serial: [cidinfo] NMBR = 4508488

#include"gd_tools.h"


#define pgVERS_ "V1.31"
#define pgTITL_ "Collect CallerID data from McMail (or other mailer) log"
#define pgCOPR_ "1997"


UCHAR   datFile[FS_LEN], iniFile[FS_LEN], iFile[FS_LEN], oFil1[]="MCM-CID.LOG",
        work[1001], work1[1001], *w, sWriteSrch[81]="", sDateSrch[81]="",
        sTimeSrch[81]="", sNameSrch[81]="", sNumberSrch[81]="",
        sDateOut[81]="", sTimeOut[81]="", sNameOut[81]="", sNumberOut[81]="",
        sStripFromEnd[81]="" ;
char    fmt[81] ;

FILE    *iFh, *oF1 ;
BOOL    ynAddFromDAT = FALSE, ynVerbose = FALSE, ynReplaceName = FALSE ;
long    lines = 0 ;
int     iLogDateSz = 4 ;                        // size of date field
int     iLogTimeSz = 4 ;                        // size of time field
int     iLogNameSz = 50 ;                       // size of name field
int     iLogNmbrSz = 15 ;                       // size of number field
int     iLogDatePos = 1 ;                       // output position of date field
int     iLogTimePos = 2 ;                       // output position of time field
int     iLogNamePos = 4 ;                       // output position of name field
int     iLogNmbrPos = 3 ;                       // output position of number field

int     iP[4], iS[4] ;                          // for use to output records
STRING  sF[4] ;                                 // for use to output records


void    show_help( void )
{
    logon(1);
    fprintf( stderr, "\n%s collects CallerID information from the McMail (or other mailer) log,\n"
                     "and appends it to the CallerID log file (by default %s).\n"
                     "\nSyntax:  %s input_logfile\n\n",
                     get_global_program_name(), oFil1,
                     get_global_program_name() );
    exit( GD_ERROR_HELP );
}


void    INIerror( STRING fldName )
{
    fprintf( stderr, "Error in INI entry for %s\n", fldName );
    exit( GD_ERROR_INVALID_PARM );
}


BOOL    get2( STRING fldName, int *val1, int *val2 )
{
    UCHAR       v1[81], v2[81], *comma ;
    int         xcnt=0 ;

    // val1 must be 1-4, val2 must be 4-50

    fl_parse_ini( iniFile, "McMailCID", fldName, work, &xcnt );

    comma = strstr( work, "," );
    if ( ! comma )
        return( ERROR );

    *comma++ = EOS ;
    ST_CPY( v1, work );
    ST_CPY( v2, comma );

    *val1 = atoi(v1);
    *val2 = atoi(v2);

    if ( *val1 < 1 || *val1 > 4 )
        return( ERROR );
    if ( *val2 < 4 || *val2 > 50 )
        return( ERROR );
    return( OK );
}


void    main_init( int argc, char *argv[] )
{
    int         x, xcnt=0 ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(1);

    if ( argc != 2 )
        show_help();

    strcpy( datFile, argv[0] );                 // create .dat file name
    {
    char *pDat ;
    pDat = strchr( datFile, '.' );
    if ( pDat != NULL )
        *pDat = EOS ;
    }
    strcat( datFile, ".DAT" );
    if ( ynVerbose )
        fprintf( stderr, "\n%s: Using data from %s\n",
                         get_global_program_name(), datFile );

    strcpy( iniFile, argv[0] );                 // create .ini file name
    {
    char *pIni ;
    pIni = strchr( iniFile, '.' );
    if ( pIni != NULL )
        *pIni = EOS ;
    }
    strcat( iniFile, ".INI" );
    if ( ynVerbose )
        fprintf( stderr, "%s: Using setup from %s\n",
                         get_global_program_name(), iniFile );

//  find strings to search for
    fl_parse_ini( iniFile, "McMailCID", "date", sDateSrch, &xcnt );
    fl_parse_ini( iniFile, "McMailCID", "time", sTimeSrch, &xcnt );
    fl_parse_ini( iniFile, "McMailCID", "name", sNameSrch, &xcnt );
    fl_parse_ini( iniFile, "McMailCID", "number", sNumberSrch, &xcnt );
    fl_parse_ini( iniFile, "McMailCID", "writeon", sWriteSrch, &xcnt );
    fl_parse_ini( iniFile, "McMailCID", "StripFromEnd", sStripFromEnd, &xcnt );

    if ( ynVerbose )
    {
        fprintf( stderr, "Search strings:\n"
                         "\t%-6s> %s\n"
                         "\t%-6s> %s\n"
                         "\t%-6s> %s\n"
                         "\t%-6s> %s\n",
                         "Date", sDateSrch,
                         "Time", sTimeSrch,
                         "Name", sNameSrch,
                         "Number", sNumberSrch );
        fprintf( stderr, "Write after processing:\n"
                         "\t\t%s\n", sWriteSrch );
        if ( strlen(sStripFromEnd) )
            fprintf( stderr, "Characters to strip from end of strings: %s\n",
                     sStripFromEnd );
    }

    fl_parse_ini( iniFile, "McMailCID", "OutLog", work, &xcnt );
    if ( strlen(work) )
        ST_CPY( oFil1, work );

//  add extra info from .dat file
    fl_parse_ini( iniFile, "McMailCID", "AddFromDAT", work, &xcnt );
    strupr( work );
    if ( work[0]=='Y' || work[0]=='T' || work[0]=='1' )
        ynAddFromDAT = TRUE ;

//  if name found on .dat file, use it instead of the CID info?
    fl_parse_ini( iniFile, "McMailCID", "ReplaceName", work, &xcnt );
    strupr( work );
    if ( work[0]=='Y' || work[0]=='T' || work[0]=='1' )
        ynReplaceName = ynAddFromDAT = TRUE ;

//  verbose setup messages
    fl_parse_ini( iniFile, "McMailCID", "Verbose", work, &xcnt );
    strupr( work );
    if ( work[0]=='Y' || work[0]=='T' || work[0]=='1' )
        ynVerbose = TRUE ;

//  length and position of info in output log
    if ( get2( "LogDate", &iLogDatePos, &iLogDateSz ) == ERROR )
        INIerror( "LogDate" );
    if ( get2( "LogTime", &iLogTimePos, &iLogTimeSz ) == ERROR )
        INIerror( "LogTime" );
    if ( get2( "LogName", &iLogNamePos, &iLogNameSz ) == ERROR )
        INIerror( "LogName" );
    if ( get2( "LogNumber", &iLogNmbrPos, &iLogNmbrSz ) == ERROR )
        INIerror( "LogNumber" );

    LOOP( x, 0, 3 , 1 )                         // initialize
    {
        iP[x] = iS[x] = 0 ;
    }
    LOOP( x, 0, 3 , 1 )                         // insert values
    {
        if ( iLogDatePos == (x+1) )             // date
        {
            if ( iP[x] == 0 )
            {
                iP[x] = iLogDatePos ;
                iS[x] = iLogDateSz ;
                sF[x] = strdup( "Date" );
            }
        }
        if ( iLogTimePos == (x+1) )             // time
        {
            if ( iP[x] == 0 )
            {
                iP[x] = iLogTimePos ;
                iS[x] = iLogTimeSz ;
                sF[x] = strdup( "Time" );
            }
        }
        if ( iLogNamePos == (x+1) )             // name
        {
            if ( iP[x] == 0 )
            {
                iP[x] = iLogNamePos ;
                iS[x] = iLogNameSz ;
                sF[x] = strdup( "Name" );
            }
        }
        if ( iLogNmbrPos == (x+1) )             // number
        {
            if ( iP[x] == 0 )
            {
                iP[x] = iLogNmbrPos ;
                if ( iLogNmbrSz > 8 )
                    iS[x] = iLogNmbrSz ;
                else
                    iS[x] = 8 ;
                sF[x] = strdup( "Number" );
            }
        }
    }

    if ( ynVerbose )
    {
        fprintf( stderr, "Output fields:\n" );
        LOOP( x, 0, 3 , 1 )                     // show values
        {
            fprintf( stderr, "\tField %d: %-6s  (size = %d bytes)\n",
                             iP[x], sF[x], iS[x] );
        }
    }

    st_cpy( iFile, (UCHAR *) argv[1], FS_LEN );
    strupr( (char *) iFile );

    if ( ( iFh = fopen( iFile, "r" ) ) == NULL )
    {
        logon(1);
        fprintf( stderr, "\n\nFile %s not found\a\n", iFile );
        show_help();
    }
    if ( ( oF1 = fopen( oFil1, "a" ) ) == NULL )
    {
        logon(1);
        fprintf( stderr, "\n\nCould not append to file %s\a\n", oFil1 );
        show_help();
    }
    if ( ynVerbose )
    {
        fprintf( stderr, "Output to %s\n"
                         "Add extra info from data file: %s\n"
                         "Replace CID name with info from data file: %s\n",
                          oFil1,
                         (ynAddFromDAT ? "yes" : "no"),
                         (ynReplaceName ? "yes" : "no") );
    }
}


void    add_extra_info( STRING phone )
{
    FILE *dFh ;
    static UCHAR *pD, d[513], ph[81] ;

    if ( ( dFh = fopen( datFile, "r" ) ) == NULL )
        return ;                                // file not present

    FOREVER
    {
        pD = fgets( d, (sizeof(d)-1), dFh );
        if ( pD )
        {
            st_trim( d );
            st_get_word( ph, d );
            if ( st_eq(phone, ph) )
            {
                st_remove_word( d );            // remove phone number
                if ( ynReplaceName )
                    fprintf( oF1, "%s", d );    // write info to replace the name
                else
                    fprintf( oF1, " (%s)", d ); // write info to append
                fclose( dFh );
                return ;
            }
        }
        if ( feof(dFh) )                        // number not found
        {
            if ( ynReplaceName )
                fprintf( oF1, fmt, sNameOut );
            fclose( dFh );
            return ;
        }
    }
}


void    format_time( STRING in )
{
    static char out[81] ;

    if ( iLogTimeSz == 4 )                      // no change - hhmm
        return ;
    if ( iLogTimeSz == 5 )                      // insert colon - hh:mm
    {
        StrInsert( in, ":", 2, 80 );
        return ;
    }
}


void    format_phone( STRING in )
{
    static char out[81] ;
    int l ;

    //  if  7 long, make xxx-xxxx
    //  if  8 long, make x-xxx-xxxx
    //  if 11 long, make x-xxx-xxx-xxxx

    st_trim( in );
    strcpy( out, in );
    l = strlen(in);
    switch ( l )
    {
        case 7 :
            StrInsert( out, "-", 3, 80 );
            break ;
        case 8 :
            StrInsert( out, "-", 4, 80 );
            StrInsert( out, "-", 1, 80 );
            break ;
        case 11:
            StrInsert( out, "-", 7, 80 );
            StrInsert( out, "-", 4, 80 );
            StrInsert( out, "-", 1, 80 );
            break ;
    }
    strcpy( in, out );
}


void    write_record( void )
{
    static int  x ;

    st_trim( sDateOut );
    st_trim( sTimeOut );
    st_trim( sNameOut );
    st_trim( sNumberOut );

    if ( strlen(sStripFromEnd) )                // do we have to strip something off the end?
    {
        x = strlen(sStripFromEnd) ;
        if ( st_eq( &sDateOut[strlen(sDateOut)-x], sStripFromEnd ) )
            sDateOut[strlen(sDateOut)-x] = EOS ;
        if ( st_eq( &sTimeOut[strlen(sTimeOut)-x], sStripFromEnd ) )
            sTimeOut[strlen(sTimeOut)-x] = EOS ;
        if ( st_eq( &sNameOut[strlen(sNameOut)-x], sStripFromEnd ) )
            sNameOut[strlen(sNameOut)-x] = EOS ;
        if ( st_eq( &sNumberOut[strlen(sNumberOut)-x], sStripFromEnd ) )
            sNumberOut[strlen(sNumberOut)-x] = EOS ;
        st_trim( sDateOut );
        st_trim( sTimeOut );
        st_trim( sNameOut );
        st_trim( sNumberOut );
    }

    if ( st_eq(sNameOut,"O") && st_eq(sNumberOut,"P") )
    {
        strcpy( sNameOut, "Anonymous Call" );
        strcpy( sNumberOut, "" );
    }
    if ( st_eq(sNameOut,"O") && st_eq(sNumberOut,"O") )
    {
        strcpy( sNameOut, "Out of Area" );
        strcpy( sNumberOut, "" );
    }
    if ( st_eq(sNameOut,"O") && strlen(sNumberOut)==11 )
        strcpy( sNameOut, "Long Distance" );

    format_phone( sNumberOut );
    format_time( sTimeOut );

    LOOP( x, 0, 3, 1 )                          // print fields
    {
        if ( iP[x] > 0 )
        {
            if ( iP[x] == 4 )                   // last field
            {
                if ( st_eq(sF[x], "Number") )
                    sprintf( fmt, "%s%d.%ds", "%", iS[x], iS[x] );
                else
                    strcpy( fmt, "%s" );
            }
            else
            {
                if ( st_eq(sF[x], "Number") )
                    sprintf( fmt, "%s%d.%ds ", "%", iS[x], iS[x] );
                else
                    sprintf( fmt, "%s%d.%ds ", "%-", iS[x], iS[x] );
            }
            if ( st_eq(sF[x], "Date") )
                fprintf( oF1, fmt, sDateOut );
            if ( st_eq(sF[x], "Time") )
                fprintf( oF1, fmt, sTimeOut );
            if ( st_eq(sF[x], "Name") )
            {
                if ( st_eq("O", sNameOut) )
                    strcpy( sNameOut, "-n/a-" );
                if ( ! ynReplaceName )
                    fprintf( oF1, fmt, sNameOut );
            }
            if ( st_eq(sF[x], "Number") )
                fprintf( oF1, fmt, sNumberOut );
        }
    }
    if ( ynAddFromDAT )
        add_extra_info( sNumberOut );
    fprintf( oF1, "\n" );
    sDateOut[0] = sTimeOut[0] = sNameOut[0] = sNumberOut[0] = EOS ;
}


void    main( int argc, char *argv[] )
{
    main_init( argc, argv );

    fprintf( stderr, "\nReading %s\n", iFile );

    FOREVER
    {
        w = fgets( work, (sizeof(work)-1), iFh );
        if ( w )
        {
            lines += 1 ;
            if ( (lines MOD 10) == 0L )
                fprintf( stderr, "\r%ld", lines );
            st_trim( work );

            w = strstr( work, sDateSrch );
            if ( w )
                strcpy( sDateOut, w+strlen(sDateSrch) );
            w = strstr( work, sTimeSrch );
            if ( w )
                strcpy( sTimeOut, w+strlen(sTimeSrch) );
            w = strstr( work, sNameSrch );
            if ( w )
                strcpy( sNameOut, w+strlen(sNameSrch) );
            w = strstr( work, sNumberSrch );
            if ( w )
                strcpy( sNumberOut, w+strlen(sNumberSrch) );

            w = strstr( work, sWriteSrch );
            if ( w )
                write_record();
        }
        if ( feof(iFh) )
        {
            _fcloseall();
            fprintf( stderr, "\rProcessed %ld lines%c\n", lines, (lines>1000L ? BELL : SPACE) );
            exit( GD_ERROR_NONE );
        }
    }
}
